@echo off
rem ######################################################################
rem ######### Auto generated batch file to prepare the RXF and ###########
rem ######### Rhapsody generated files for building in an      ###########
rem ######### external IDE.                                    ###########
rem ######################################################################
rem ##
rem ## Based on properties version:
rem ## $Id: WST_RXF_V6.prp 35025 2016-08-09 11:42:33Z eroemer $
rem ## $URL: https://svn.willert.de/V6/trunk/Component/Modelling/Rpy/Config/UserSettings/WST_RXF_V6.prp $
rem ##

set WST_JAVA_PATH="C:\IBM\Rational\Rhapsody\8.2.1\jdk\jre\bin"
set WST_RELEASE_PATH=C:\Program Files (x86)\Willert\Rpy_C_CMSIS_Keil5_ARM_MCB1700_TD_V6.01
set WST_RELEASE_MEMSECTIONS=%WST_RELEASE_PATH%\Config\MemorySections
set WST_RELEASE_TOOLS=%WST_RELEASE_PATH%\Tools
set MYECHO="%WST_RELEASE_TOOLS%\MyEcho"

@%MYECHO% Preparing header files for environment Rpy_C_CMSIS_Keil5_ARM_MCB1700_TD_V6_01...

set TARGET_TYPE=Executable
set TARGET_NAME=Cortex_CMP
set BUILDSET=Debug
set COMPILE_SWITCHES_PRP=-DWST_RXF_V6  $(CPPCompileDebug)

rem The batch file cannot expand the $(CPPCompileDebug) inside -DWST_RXF_V6  $(CPPCompileDebug), so we remove that from the string and add it manually dependent on the active buildset.
if "%BUILDSET%" == "Debug" set RPY_COMPILE_SWITCHES=%COMPILE_SWITCHES_PRP:$(CPPCompileDebug)=% -D_DEBUG -DWST_CFG_HIGHWATERMARKS 
if "%BUILDSET%" == "Release" set RPY_COMPILE_SWITCHES=%COMPILE_SWITCHES_PRP:$(CPPCompileRelease)=% -DNDEBUG 

if "%1" == "clean" (
	call :clean
	goto end
)
if "%1"=="rebuild" (
	call :clean
)
call :CreateOutput

%WST_JAVA_PATH%"\java" -jar "%WST_RELEASE_TOOLS%/CheckModified.jar" TargetComponent.bat RxfDimensions.h
if errorlevel == 1	 			call :RxfDimensions
        
%WST_JAVA_PATH%"\java" -jar "%WST_RELEASE_TOOLS%/CheckModified.jar" TargetComponent.bat RxfConstants.h
if errorlevel == 1				call :RxfConstants


call :DeployerFileLists


%WST_JAVA_PATH%"\java" -jar "%WST_RELEASE_TOOLS%/CheckModified.jar" TargetComponent.bat WSTMemoryTypes.h
if errorlevel == 1	 			call :WSTMemoryTypes  


goto end


rem ############################### CLEAN ##############################
:clean
%MYECHO% -------
%MYECHO% Cleaning
%MYECHO% -------
if exist RxfDimensions.h  	 		del RxfDimensions.h
if exist RxfConstants.h  	 		del RxfConstants.h
if exist WSTMemoryTypes.h  	 		del WSTMemoryTypes.h 
exit /B


rem ############################ CreateOutput ###########################
:CreateOutput
rem Generate output exe or lib to enable Run button:
if "%TARGET_TYPE%" == "Executable" %MYECHO% > %TARGET_NAME%.dat
if "%TARGET_TYPE%" == "Library" %MYECHO% > %TARGET_NAME%.lib
exit /B


rem ############################ WSTMemoryTypes ###########################
:WSTMemoryTypes
%MYECHO% -------
%MYECHO% Creating WSTMemoryTypes.h
%MYECHO% -------
rem -------------------------------------------------------------------------------------------------------
rem IMPORTANT NOTE REGARDING MEMORY SECTION MECHANISM:
rem -------------------------------------------------------------------------------------------------------
rem The RXF allows to generate WSTMemoryTypes.h with the compiler pragmas needed to define named sections.
rem To enable this mechanism, please install gnu awk and make it available in your PATH environment and
rem remove the "rem" comment-statements in the following three lines while adding "rem" to the default line
rem which creates an empty WSTMemoryTypes.h file to speed up compilation.
rem -------------------------------------------------------------------------------------------------------
rem if not exist "WSTMemoryTypeMacro.template" copy "%WST_RELEASE_MEMSECTIONS%\WSTMemoryTypeMacro.template" WSTMemoryTypeMacro.template
rem if not exist "WSTMemoryTypePragmas.txt" copy "%WST_RELEASE_MEMSECTIONS%\WSTMemoryTypePragmas.txt" WSTMemoryTypePragmas.txt
rem awk.exe -f "%WST_RELEASE_TOOLS%\macroAndPragma2Header.awk" pragmaFile=WSTMemoryTypePragmas.txt useShortSectionNames=0 WSTMemoryTypeMacro.template > WSTMemoryTypes.h
%MYECHO% /* Empty memory section allocation file to speed up compilation. Please see MakefileContent property for details. */ > WSTMemoryTypes.h
exit /B


rem ############################ RxfDimensions ###########################
:RxfDimensions
rem Generate RxfDimensions.h with all actual dimensions, set via properties in Rhapsody
%MYECHO% -------
%MYECHO% Generating RxfDimensions.h
%MYECHO% -------
%MYECHO% /* This file is generated by Cortex_CMP.bat; do not edit! */					>  RxfDimensions.h
%MYECHO% 																				>> RxfDimensions.h


%MYECHO% ^#define WST_MAX_TIMEOUTS					32U					>> RxfDimensions.h



%MYECHO% ^#define WST_TSK_DEFAULT_MESSAGE_QUEUE_SIZE	32U			>> RxfDimensions.h
%MYECHO% ^#define WST_TSK_DEFAULT_STACK_SIZE			512U		>> RxfDimensions.h
%MYECHO% ^#define WST_RTOS_MAIN_STACK_SIZE				512U		>> RxfDimensions.h
%MYECHO% ^#define WST_MONITOR_TASK_PRIORITY				WST_RTOS_TASK_PRIORITY_LOW		>> RxfDimensions.h
%MYECHO% ^#define WST_MAIN_TASK_PRIORITY				WST_RTOS_TASK_PRIORITY_NORMAL			>> RxfDimensions.h
%MYECHO% ^#define WST_TSK_DEFAULT_PRIORITY				WST_RTOS_TASK_PRIORITY_NORMAL		>> RxfDimensions.h
%MYECHO% ^#define WST_TMM_TASK_PRIORITY					WST_RTOS_TASK_PRIORITY_HIGHEST		>> RxfDimensions.h  
%MYECHO% ^#define WST_TMM_TASK_STACK_SIZE				512U		>> RxfDimensions.h
                                                                                                 	

%MYECHO% ^#define WST_TINY_BUFFER_SIZE					0U			>> RxfDimensions.h
%MYECHO% ^#define WST_SMALL_BUFFER_SIZE					16U			>> RxfDimensions.h
%MYECHO% ^#define WST_MEDIUM_BUFFER_SIZE				32U			>> RxfDimensions.h
%MYECHO% ^#define WST_LARGE_BUFFER_SIZE					96U			>> RxfDimensions.h
%MYECHO% ^#define WST_HUGE_BUFFER_SIZE					0U			>> RxfDimensions.h
%MYECHO% ^#define WST_INITIAL_TINY_BUFFERS				0U		>> RxfDimensions.h
%MYECHO% ^#define WST_INITIAL_SMALL_BUFFERS				12U		>> RxfDimensions.h
%MYECHO% ^#define WST_INITIAL_MEDIUM_BUFFERS			6U		>> RxfDimensions.h
%MYECHO% ^#define WST_INITIAL_LARGE_BUFFERS				2U		>> RxfDimensions.h
%MYECHO% ^#define WST_INITIAL_HUGE_BUFFERS				0U		>> RxfDimensions.h
%MYECHO% ^#define WST_MS_PER_TICK						10U			>> RxfDimensions.h
exit /B


rem ############################ RxfConstants ###########################
:RxfConstants
rem The file RxfConstants.h is included by WST.h which is included by the RXF sources 
%MYECHO% ---------
%MYECHO% Generating RxfConstants.h
%MYECHO% ---------
%MYECHO% /* This file is generated by Cortex_CMP.bat via Rhapsody; do not edit! */		>  RxfConstants.h
%MYECHO% -@D@ %RPY_COMPILE_SWITCHES%														>> RxfConstants.h
%MYECHO% -@D@ 												>> RxfConstants.h
%MYECHO% -@D@ 													>> RxfConstants.h
%MYECHO% -@D@ 													>> RxfConstants.h
%MYECHO% -@D@ -DWST_RPY_VTBL_KIND_OXF									>> RxfConstants.h

exit /B


rem ############################ DeployerFileLists ###########################
:DeployerFileLists
rem We need to extract macros, so we handle deployer file lists
rem here and not in RhapsodyMake.bat.
if not exist CurrentFileList.txt copy NUL CurrentFileList.txt
copy CurrentFileList.txt PreviousFileList.txt
dir /s /on /b  *.c *.h > CurrentFileList.txt
exit /B


rem ############################ THE END ###########################
:end
