/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: GLCD
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\GLCD.c
*********************************************************************/

/*## auto_generated */
#include "GLCD.h"
/*## package b_GraphicLibPkg */

/*## class GLCD */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


/*## operation Init(orientation_t,position_t) */
void GLCD_Init(GLCD* const me, const orientation_t aLandscape, const position_t aPosition)
{
    me->bgndColor = 0xFFFF;
    me->textColor = 0x0000;
    {
        /*#[ operation Init(orientation_t,position_t) */
        me->orientation = aLandscape;
        me->position    = aPosition; 
        me->bpp         = 16;
        me->bypp        = ( me->bpp + 7 ) / 8;
        
        SPI_initialize();
        
        if ( me->orientation == OR_Landscape )
        {
        	me->height = 240;
        	me->width  = 320;
        }
        else
        {
        	me->height = 320;
        	me->width  = 240;
        }
        
        GLCD_setBgndColor(me, clrWhite);
        GLCD_setTextColor(me, clrBlack);
        
        if (SPI_getDriverCode() == 0x47)            /* LCD with HX8347-D LCD Controller   */
        {
        	/* Driving ability settings ----------------------------------------------*/
        	SPI_wr_reg(0xEA, 0x00);                 /* Power control internal used (1)    */
        	SPI_wr_reg(0xEB, 0x20);                 /* Power control internal used (2)    */
        	SPI_wr_reg(0xEC, 0x0C);                 /* Source control internal used (1)   */
        	SPI_wr_reg(0xED, 0xC7);                 /* Source control internal used (2)   */
        	SPI_wr_reg(0xE8, 0x38);                 /* Source output period Normal mode   */
        	SPI_wr_reg(0xE9, 0x10);                 /* Source output period Idle mode     */
        	SPI_wr_reg(0xF1, 0x01);                 /* RGB 18-bit interface ;0x0110       */
        	SPI_wr_reg(0xF2, 0x10);
        	
        	/* Adjust the Gamma Curve ------------------------------------------------*/
        	SPI_wr_reg(0x40, 0x01);
        	SPI_wr_reg(0x41, 0x00);
        	SPI_wr_reg(0x42, 0x00);
        	SPI_wr_reg(0x43, 0x10);
        	SPI_wr_reg(0x44, 0x0E);
        	SPI_wr_reg(0x45, 0x24);
        	SPI_wr_reg(0x46, 0x04);
        	SPI_wr_reg(0x47, 0x50);
        	SPI_wr_reg(0x48, 0x02);
        	SPI_wr_reg(0x49, 0x13);
        	SPI_wr_reg(0x4A, 0x19);
        	SPI_wr_reg(0x4B, 0x19);
        	SPI_wr_reg(0x4C, 0x16);
        	
        	SPI_wr_reg(0x50, 0x1B);
        	SPI_wr_reg(0x51, 0x31);
        	SPI_wr_reg(0x52, 0x2F);
        	SPI_wr_reg(0x53, 0x3F);
        	SPI_wr_reg(0x54, 0x3F);
        	SPI_wr_reg(0x55, 0x3E);
        	SPI_wr_reg(0x56, 0x2F);
        	SPI_wr_reg(0x57, 0x7B);
        	SPI_wr_reg(0x58, 0x09);
        	SPI_wr_reg(0x59, 0x06);
        	SPI_wr_reg(0x5A, 0x06);
        	SPI_wr_reg(0x5B, 0x0C);
        	SPI_wr_reg(0x5C, 0x1D);
        	SPI_wr_reg(0x5D, 0xCC);
        	
        	/* Power voltage setting -------------------------------------------------*/
        	SPI_wr_reg(0x1B, 0x1B);
        	SPI_wr_reg(0x1A, 0x01);
        	SPI_wr_reg(0x24, 0x2F);
        	SPI_wr_reg(0x25, 0x57);
        	SPI_wr_reg(0x23, 0x88);
        	
        	/* Power on setting ------------------------------------------------------*/
        	SPI_wr_reg(0x18, 0x36);                 /* Internal oscillator frequency adj  */
        	SPI_wr_reg(0x19, 0x01);                 /* Enable internal oscillator         */
        	SPI_wr_reg(0x01, 0x00);                 /* Normal mode, no scrool             */
        	SPI_wr_reg(0x1F, 0x88);                 /* Power control 6 - DDVDH Off        */
        	
        	SPI_delay(20);
        	
        	SPI_wr_reg(0x1F, 0x82);                 /* Power control 6 - Step-up: 3 x VCI */
        	
        	SPI_delay(5);
        	
        	SPI_wr_reg(0x1F, 0x92);                 /* Power control 6 - Step-up: On      */
        	
        	SPI_delay(5);
        	
        	SPI_wr_reg(0x1F, 0xD2);                 /* Power control 6 - VCOML active     */
        	
        	SPI_delay(5);
        	
        	/* Color selection -------------------------------------------------------*/
        	SPI_wr_reg(0x17, 0x55);                 /* RGB, System interface: 16 Bit/Pixel*/
        	SPI_wr_reg(0x00, 0x00);                 /* Scrolling off, no standby          */
        	
        	/* Interface config ------------------------------------------------------*/
        	SPI_wr_reg(0x2F, 0x11);                 /* LCD Drive: 1-line inversion        */
        	SPI_wr_reg(0x31, 0x00);
        	SPI_wr_reg(0x32, 0x00);                 /* DPL=0, HSPL=0, VSPL=0, EPL=0       */
        	
        	/* Display on setting ----------------------------------------------------*/
        	SPI_wr_reg(0x28, 0x38);                 /* PT(0,0) active, VGL/VGL            */
        	SPI_delay(20);
        	SPI_wr_reg(0x28, 0x3C);                 /* Display active, VGL/VGL            */
        	
        	if ( me->orientation == OR_Landscape )
        	{
        		if ( me->position == PO_Straight )
        		{
        			SPI_wr_reg (0x16, 0xA8);
        		}
        		else
        		{
        			SPI_wr_reg (0x16, 0x68);
        		}
        	}
        	else
        	{
        		if ( me->position == PO_Straight )
        		{
        			SPI_wr_reg (0x16, 0x08);
        		}
        		else
        		{
        			SPI_wr_reg (0x16, 0xC8);
        		}
        	}
        	
        	/* Display scrolling settings --------------------------------------------*/
        	SPI_wr_reg(0x0E, 0x00);                 /* TFA MSB                            */
        	SPI_wr_reg(0x0F, 0x00);                 /* TFA LSB                            */
        	SPI_wr_reg(0x10, 320 >> 8);             /* VSA MSB                            */
        	SPI_wr_reg(0x11, 320 &  0xFF);          /* VSA LSB                            */
        	SPI_wr_reg(0x12, 0x00);                 /* BFA MSB                            */
        	SPI_wr_reg(0x13, 0x00);                 /* BFA LSB                            */
        }
        else
        {
        	/* Start Initial Sequence ------------------------------------------------*/
        	if ( me->position == PO_UpsideDown )
        	{
        		SPI_wr_reg(0x01, 0x0000);           /* Clear SS bit                       */
        	}
        	else
        	{
        		SPI_wr_reg(0x01, 0x0100);           /* Set SS bit                         */
        	}
        
        	SPI_wr_reg(0x02, 0x0700);               /* Set 1 line inversion               */
        	SPI_wr_reg(0x04, 0x0000);               /* Resize register                    */
        	SPI_wr_reg(0x08, 0x0207);               /* 2 lines front, 7 back porch        */
        	SPI_wr_reg(0x09, 0x0000);               /* Set non-disp area refresh cyc ISC  */
        	SPI_wr_reg(0x0A, 0x0000);               /* FMARK function                     */
        	SPI_wr_reg(0x0C, 0x0000);               /* RGB interface setting              */
        	SPI_wr_reg(0x0D, 0x0000);               /* Frame marker Position              */
        	SPI_wr_reg(0x0F, 0x0000);               /* RGB interface polarity             */
        	
        	/* Power On sequence -----------------------------------------------------*/
        	SPI_wr_reg(0x10, 0x0000);               /* Reset Power Control 1              */
        	SPI_wr_reg(0x11, 0x0000);               /* Reset Power Control 2              */
        	SPI_wr_reg(0x12, 0x0000);               /* Reset Power Control 3              */
        	SPI_wr_reg(0x13, 0x0000);               /* Reset Power Control 4              */
        	
        	SPI_delay(20);                          	/* Discharge cap power voltage (200ms)*/
        	
        	SPI_wr_reg(0x10, 0x12B0);               /* SAP, BT[3:0], AP, DSTB, SLP, STB   */
        	SPI_wr_reg(0x11, 0x0007);               /* DC1[2:0], DC0[2:0], VC[2:0]        */
        	
        	SPI_delay(5);                           	/* Delay 50 ms                        */
        	
        	SPI_wr_reg(0x12, 0x01BD);               /* VREG1OUT voltage                   */
        	
        	SPI_delay(5);                           	/* Delay 50 ms                        */
        	
        	SPI_wr_reg(0x13, 0x1400);               /* VDV[4:0] for VCOM amplitude        */
        	SPI_wr_reg(0x29, 0x000E);               /* VCM[4:0] for VCOMH                 */
        
        	SPI_delay(5);                           	/* Delay 50 ms                        */
        	
        	SPI_wr_reg(0x20, 0x0000);               /* GRAM horizontal Address            */
        	SPI_wr_reg(0x21, 0x0000);               /* GRAM Vertical Address              */
        	
        	/* Adjust the Gamma Curve ------------------------------------------------*/
        	switch ( SPI_getDriverCode() ) 
        	{
        	  case 0x5408:                      /* LCD with SPFD5408 LCD Controller   */
        	    SPI_wr_reg(0x30, 0x0B0D);
        	    SPI_wr_reg(0x31, 0x1923);
        	    SPI_wr_reg(0x32, 0x1C26);
        	    SPI_wr_reg(0x33, 0x261C);
        	    SPI_wr_reg(0x34, 0x2419);
        	    SPI_wr_reg(0x35, 0x0D0B);
        	    SPI_wr_reg(0x36, 0x1006);
        	    SPI_wr_reg(0x37, 0x0610);
        	    SPI_wr_reg(0x38, 0x0706);
        	    SPI_wr_reg(0x39, 0x0304);
        	    SPI_wr_reg(0x3A, 0x0E05);
        	    SPI_wr_reg(0x3B, 0x0E01);
        	    SPI_wr_reg(0x3C, 0x010E);
        	    SPI_wr_reg(0x3D, 0x050E);
        	    SPI_wr_reg(0x3E, 0x0403);
        	    SPI_wr_reg(0x3F, 0x0607);
        	    break;
        	
        	  case 0x9325:                      /* LCD with RM68050 LCD Controller    */
        	    SPI_wr_reg(0x0030,0x0000);
        	    SPI_wr_reg(0x0031,0x0607);
        	    SPI_wr_reg(0x0032,0x0305);
        	    SPI_wr_reg(0x0035,0x0000);
        	    SPI_wr_reg(0x0036,0x1604);
        	    SPI_wr_reg(0x0037,0x0204);
        	    SPI_wr_reg(0x0038,0x0001);
        	    SPI_wr_reg(0x0039,0x0707);
        	    SPI_wr_reg(0x003C,0x0000);
        	    SPI_wr_reg(0x003D,0x000F);
        	    break;
        	
        	  case 0x9320:                      /* LCD with ILI9320 LCD Controller    */
        	  default:                          /* LCD with other LCD Controller      */
        	    SPI_wr_reg(0x30, 0x0006);
        	    SPI_wr_reg(0x31, 0x0101);
        	    SPI_wr_reg(0x32, 0x0003);
        	    SPI_wr_reg(0x35, 0x0106);
        	    SPI_wr_reg(0x36, 0x0B02);
        	    SPI_wr_reg(0x37, 0x0302);
        	    SPI_wr_reg(0x38, 0x0707);
        	    SPI_wr_reg(0x39, 0x0007);
        	    SPI_wr_reg(0x3C, 0x0600);
        	    SPI_wr_reg(0x3D, 0x020B);
        	    break;
        	}
        	
        	/* Set GRAM area ---------------------------------------------------------*/
        	SPI_wr_reg(0x50, 0x0000);               /* Horizontal GRAM Start Address      */
        	SPI_wr_reg(0x51, (me->height - 1));           /* Horizontal GRAM End   Address      */
        	SPI_wr_reg(0x52, 0x0000);               /* Vertical   GRAM Start Address      */
        	SPI_wr_reg(0x53, (me->width - 1));            /* Vertical   GRAM End   Address      */
        	
        	/* Set Gate Scan Line ----------------------------------------------------*/
        	switch ( SPI_getDriverCode() ) {
        	  case 0x5408:                      /* LCD with SPFD5408 LCD Controller   */
        	  case 0x9325:                      /* LCD with RM68050 LCD Controller    */
        	  	if ( me->orientation ^ me->position )
        	  	{
        	    	SPI_wr_reg(0x60, 0x2700);
        	  	}
        	  	else
        	  	{
        	    	SPI_wr_reg(0x60, 0xA700);
        	  	}
        	    break;
        	
        	  case 0x9320:                      /* LCD with ILI9320 LCD Controller    */
        	  default:                          /* LCD with other LCD Controller      */
        	  	if ( me->orientation ^ me->position )
        	  	{
        	    	SPI_wr_reg(0x60, 0xA700);
        	  	}
        	  	else
        	  	{
        	    	SPI_wr_reg(0x60, 0x2700);
        	  	}
        	    break;
        	}
        
        	SPI_wr_reg(0x61, 0x0001);               /* NDL,VLE, REV                       */
        	SPI_wr_reg(0x6A, 0x0000);               /* Set scrolling line                 */
        	
        	/* Partial Display Control -----------------------------------------------*/
        	SPI_wr_reg(0x80, 0x0000);
        	SPI_wr_reg(0x81, 0x0000);
        	SPI_wr_reg(0x82, 0x0000);
        	SPI_wr_reg(0x83, 0x0000);
        	SPI_wr_reg(0x84, 0x0000);
        	SPI_wr_reg(0x85, 0x0000);
        	
        	/* Panel Control ---------------------------------------------------------*/
        	SPI_wr_reg(0x90, 0x0010);
        	SPI_wr_reg(0x92, 0x0000);
        	SPI_wr_reg(0x93, 0x0003);
        	SPI_wr_reg(0x95, 0x0110);
        	SPI_wr_reg(0x97, 0x0000);
        	SPI_wr_reg(0x98, 0x0000);
        	
        	/* Set GRAM write direction
        	   I/D=11 (Horizontal : increment, Vertical : increment)                  */
        	if ( me->orientation == OR_Portrait )
        	{
        		/* AM=1   (address is updated in vertical writing direction)              */
        		SPI_wr_reg(0x03, 0x1038);
        	}
        	else
        	{
        		/* AM=0   (address is updated in horizontal writing direction)            */
        		SPI_wr_reg(0x03, 0x1030);
        	}
        		
        	SPI_wr_reg(0x07, 0x0137);               /* 262K color and display ON          */
        }
        
        LPC_GPIO4->FIOSET = 0x10000000;
    
        /*#]*/
    }
}

/*## operation DisplayChar(uint16_t,uint16_t,uint8_t,int8_t) */
void GLCD_DisplayChar(GLCD* const me, const uint16_t aLine, const uint16_t aCol, const uint8_t aFont, const int8_t aChar)
{
    /*#[ operation DisplayChar(uint16_t,uint16_t,uint8_t,int8_t) */
    uint8 tempChar;
    
    tempChar = aChar - 32;
    
    switch (aFont) 
    {
    	case 0:  /* Font 6 x 8 */
    	  GLCD_DrawChar(me, aCol *  6, aLine *  8,  6,  8, (int8_t *)&Font_6x8_h  [tempChar * 8]);
    	  break;
    	case 1:  /* Font 16 x 24 */
    	  GLCD_DrawChar(me, aCol * 16, aLine * 24, 16, 24, (int8_t *)&Font_16x24_h[tempChar * 24]);
    	  break;
    }
    
    /*#]*/
}

/*## operation DisplayString(uint16_t,uint16_t,uint8_t,int8_t) */
void GLCD_DisplayString(GLCD* const me, const uint16_t aLine, uint16_t aCol, const uint8_t aFont, int8_t* aString)
{
    /*#[ operation DisplayString(uint16_t,uint16_t,uint8_t,int8_t) */
    while (*aString) 
    {
    	GLCD_DisplayChar(me, aLine, aCol++, aFont, *aString++);
    }
    /*#]*/
}

/*## operation DrawChar(uint16_t,uint16_t,uint16_t,uint16_t,int8_t) */
void GLCD_DrawChar(GLCD* const me, const uint16_t aX, const uint16_t aY, const uint16_t aCW, const uint16_t aCH, int8_t* aChar)
{
    /*#[ operation DrawChar(uint16_t,uint16_t,uint16_t,uint16_t,int8_t) */
    uint32 i, j, k, pixs;
    
    GLCD_SetWindow(me, aX, aY, aCW, aCH);
    
    SPI_wr_cmd(0x22);
    SPI_wr_dat_start();
    
    
    k  = (aCW + 7)/8;
    
    if (k == 1)
    {
    	for (j = 0; j < aCH; j++) 
    	{
    		pixs = *(uint8_t  *) aChar;
    		aChar += 1;
    		
    		for (i = 0; i < aCW; i++) 
    		{
    			SPI_wr_dat_only ( ((pixs >> i) & 1) ? me->textColor : me->bgndColor );
    		}
    	}
    }
    else 
    {
    	if (k == 2) 
    	{
    		for (j = 0; j < aCH; j++) 
    		{
    			pixs = *(uint16_t *) aChar;
    			aChar += 2;
    			
    			for (i = 0; i < aCW; i++) 
    			{
    				SPI_wr_dat_only ( ((pixs >> i) & 1) ? me->textColor : me->bgndColor );
    			}
    		}
    	}
    }
    SPI_wr_dat_stop();
    
    /*#]*/
}

/*## operation Clear() */
void GLCD_Clear(GLCD* const me)
{
    /*#[ operation Clear() */
    unsigned int i;
    
    GLCD_WindowMax( me );
    SPI_wr_cmd(0x22);
    SPI_wr_dat_start();
    
    for(i = 0; i < ( me->height * me->width ); i++)
    {
    	SPI_wr_dat_only( me->bgndColor );
    }
    SPI_wr_dat_stop();  
    
    /*#]*/
}

/*## operation ClearColor(uint16_t) */
void GLCD_ClearColor(GLCD* const me, const uint16_t aColor)
{
    /*#[ operation ClearColor(uint16_t) */
    unsigned int i;
    
    GLCD_WindowMax( me );
    SPI_wr_cmd(0x22);
    SPI_wr_dat_start();
    
    for(i = 0; i < ( me->height * me->width ); i++)
    {
    	SPI_wr_dat_only(aColor);
    }
    SPI_wr_dat_stop();  
    
    /* Store the current color in bgcolor for redraw */
    GLCD_setBgndColor(me, aColor);
    
    
    /*#]*/
}

/*## operation ClearLn(uint16_t,uint8_t) */
void GLCD_ClearLn(GLCD* const me, const uint16_t ln, const uint8_t fi)
{
    /*#[ operation ClearLn(uint16_t,uint8_t) */
    uint8_t i;
     int8_t buf[60];
    
    GLCD_WindowMax(me);
    
    switch (fi) 
    {
    	case 0:  /* Font 6 x 8 */
    	  for (i = 0; i < (me->width+5)/6; i++)
    	  {
    	    buf[i] = ' ';
    	  }
    	  buf[i+1] = 0;
    	  break;
    	
    	case 1:  /* Font 16 x 24 */
    	  for (i = 0; i < (me->width+15)/16; i++)
    	  {
    	    buf[i] = ' ';
    	  }
    	  buf[i+1] = 0;
    	  break;
    	  
    	default:
    	  // Error!
    	  break;
    }
    GLCD_DisplayString (me, ln, 0, fi, buf);
    
    /*#]*/
}

/*## operation BarGraph(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
void GLCD_BarGraph(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t w, const uint16_t h, const uint16_t val)
{
    /*#[ operation BarGraph(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
    int32_t i,j;
    uint16_t	tempVal;
    
    tempVal = (val * w) >> 10;                /* Scale value */
    
    GLCD_SetWindow(me, x, y, w, h); 
    
    SPI_wr_cmd(0x22);
    SPI_wr_dat_start();  
    
    for (i = 0; i < h; i++) 
    {
    	for (j = 0; j <= w-1; j++) 
    	{
    	  if(j >= tempVal) 
    	  {
    	    SPI_wr_dat_only( me->bgndColor );
    	  } 
    	  else 
    	  {
    	    SPI_wr_dat_only( me->textColor );
    	  }
    	}
    }
    SPI_wr_dat_stop();
    
    /*#]*/
}

/*## operation Bitmap(uint16_t,uint16_t,uint16_t,uint16_t,uint8_t) */
void GLCD_Bitmap(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t w, const uint16_t h, uint8_t* bitmap)
{
    /*#[ operation Bitmap(uint16_t,uint16_t,uint16_t,uint16_t,uint8_t) */
    int i, j;
    unsigned short *bitmap_ptr = (unsigned short *)bitmap;
    
    GLCD_SetWindow (me, x, y, w, h);
    
    SPI_wr_cmd(0x22);
    SPI_wr_dat_start(); 
    
    for (i = (h-1)*w; i > -1; i -= w) 
    {
    	for (j = 0; j < w; j++) 
    	{
    	  SPI_wr_dat_only (bitmap_ptr[i+j]);
    	}
    }
    SPI_wr_dat_stop();
    
    /*#]*/
}

/*## operation WindowMax() */
void GLCD_WindowMax(GLCD* const me)
{
    /*#[ operation WindowMax() */
    GLCD_SetWindow (me, 0, 0, me->width, me->height );
    
    /*#]*/
}

/*## operation PutPixel(uint16_t,uint16_t) */
void GLCD_PutPixel(GLCD* const me, const uint16_t x, const uint16_t y)
{
    /*#[ operation PutPixel(uint16_t,uint16_t) */
    if ( SPI_isHiMax() ) 
    {
    	SPI_wr_reg(0x02, x >>    8);            /* Column address start MSB           */
    	SPI_wr_reg(0x03, x &  0xFF);            /* Column address start LSB           */
    	SPI_wr_reg(0x04, x >>    8);            /* Column address end MSB             */
    	SPI_wr_reg(0x05, x &  0xFF);            /* Column address end LSB             */
    	
    	SPI_wr_reg(0x06, y >>    8);            /* Row address start MSB              */
    	SPI_wr_reg(0x07, y &  0xFF);            /* Row address start LSB              */
    	SPI_wr_reg(0x08, y >>    8);            /* Row address end MSB                */
    	SPI_wr_reg(0x09, y &  0xFF);            /* Row address end LSB                */
    }
    else 
    {
    	if ( me->orientation == OR_Landscape )
    	{
    		SPI_wr_reg(0x20, y);
    		SPI_wr_reg(0x21, x);
    	}
    	else
    	{
    		SPI_wr_reg(0x20, x);
    		SPI_wr_reg(0x21, y);
    	}
    }
    
    SPI_wr_cmd(0x22);
    SPI_wr_dat( me->textColor );
    
    /*#]*/
}

/*## operation SetWindow(uint16_t,uint16_t,uint16_t,uint16_t) */
void GLCD_SetWindow(GLCD* const me, const uint16_t aX, const uint16_t aY, const uint16_t aW, const uint16_t aH)
{
    /*#[ operation SetWindow(uint16_t,uint16_t,uint16_t,uint16_t) */
    unsigned int xe, ye;
    
    if ( SPI_isHiMax() ) 
    {
    	xe = aX+aW-1;
    	ye = aY+aH-1;
    	
    	SPI_wr_reg(0x02, aX >>    8);           /* Column address start MSB           */
    	SPI_wr_reg(0x03, aX &  0xFF);           /* Column address start LSB           */
    	SPI_wr_reg(0x04, xe >>    8);           /* Column address end MSB             */
    	SPI_wr_reg(0x05, xe &  0xFF);           /* Column address end LSB             */
    	
    	SPI_wr_reg(0x06, aY >>    8);           /* Row address start MSB              */
    	SPI_wr_reg(0x07, aY &  0xFF);           /* Row address start LSB              */
    	SPI_wr_reg(0x08, ye >>    8);           /* Row address end MSB                */
    	SPI_wr_reg(0x09, ye &  0xFF);           /* Row address end LSB                */
    }
    else 
    {
    	if ( me->orientation == OR_Landscape )
    	{
    		SPI_wr_reg(0x50, aY);               /* Vertical   GRAM Start Address      */
    		SPI_wr_reg(0x51, aY+aH-1);          /* Vertical   GRAM End   Address (-1) */
    		SPI_wr_reg(0x52, aX);               /* Horizontal GRAM Start Address      */
    		SPI_wr_reg(0x53, aX+aW-1);          /* Horizontal GRAM End   Address (-1) */
    		SPI_wr_reg(0x20, aY);
    		SPI_wr_reg(0x21, aX);
    	}
    	else
    	{
    		SPI_wr_reg(0x50, aX);               /* Horizontal GRAM Start Address      */
    		SPI_wr_reg(0x51, aX+aW-1);          /* Horizontal GRAM End   Address (-1) */
    		SPI_wr_reg(0x52, aY);               /* Vertical   GRAM Start Address      */
    		SPI_wr_reg(0x53, aY+aH-1);          /* Vertical   GRAM End   Address (-1) */
    		SPI_wr_reg(0x20, aX);
    		SPI_wr_reg(0x21, aY);
    	}
    }
    
    /*#]*/
}

/*## operation ScrollVertical(uint16_t) */
void GLCD_ScrollVertical(GLCD* const me, const uint16_t dy)
{
    /*#[ operation ScrollVertical(uint16_t) */
    if ( me->orientation == OR_Landscape )
    {
      static unsigned int y = 0;
    
      y = y + dy;
      while ( y >= me->height )
      {
        y -= me->height;
      }
      
      if ( SPI_isHiMax() ) 
      {
        SPI_wr_reg(0x01, 0x08);
        SPI_wr_reg(0x14, y>>8);                 /* VSP MSB                            */
        SPI_wr_reg(0x15, y&0xFF);               /* VSP LSB                            */
      }
      else 
      {
        SPI_wr_reg(0x6A, y);
        SPI_wr_reg(0x61, 3);
      }
    }
    
    /*#]*/
}

/*## operation PutPixelColor(uint16_t,uint16_t,uint16_t) */
void GLCD_PutPixelColor(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t color)
{
    /*#[ operation PutPixelColor(uint16_t,uint16_t,uint16_t) */
    if ( SPI_isHiMax() ) 
    {
    	SPI_wr_reg(0x02, x >>    8);            /* Column address start MSB           */
    	SPI_wr_reg(0x03, x &  0xFF);            /* Column address start LSB           */
    	SPI_wr_reg(0x04, x >>    8);            /* Column address end MSB             */
    	SPI_wr_reg(0x05, x &  0xFF);            /* Column address end LSB             */
    	
    	SPI_wr_reg(0x06, y >>    8);            /* Row address start MSB              */
    	SPI_wr_reg(0x07, y &  0xFF);            /* Row address start LSB              */
    	SPI_wr_reg(0x08, y >>    8);            /* Row address end MSB                */
    	SPI_wr_reg(0x09, y &  0xFF);            /* Row address end LSB                */
    }
    else 
    {
    	if ( me->orientation == OR_Landscape )
    	{
    		SPI_wr_reg(0x20, y);
    		SPI_wr_reg(0x21, x);
    	}
    	else
    	{
    		SPI_wr_reg(0x20, x);
    		SPI_wr_reg(0x21, y);
    	}
    }
    
    SPI_wr_cmd(0x22);
    SPI_wr_dat( color );
    
    /*#]*/
}

/*## operation setBgndColor(uint16_t) */
void GLCD_setBgndColor(GLCD* const me, const uint16_t aVal)
{
    /*#[ operation setBgndColor(uint16_t) */
    me->bgndColor = aVal;
    
    /*#]*/
}

/*## operation setTextColor(uint16_t) */
void GLCD_setTextColor(GLCD* const me, const uint16_t aVal)
{
    /*#[ operation setTextColor(uint16_t) */
    me->textColor = aVal;
    
    /*#]*/
}

/*## operation Cleanup() */
void GLCD_Cleanup(GLCD* const me)
{
    /*#[ operation Cleanup() */
    /*#]*/
}

GLCD * GLCD_Create(const orientation_t aLandscape, const position_t aPosition)
{
    GLCD* me = (GLCD *) malloc(sizeof(GLCD));
    if(me!=NULL)
        {
            GLCD_Init(me, aLandscape, aPosition);
        }
    return me;
}

void GLCD_Destroy(GLCD* const me)
{
    if(me!=NULL)
        {
            GLCD_Cleanup(me);
        }
    free(me);
}


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

/*********************************************************************
	File Path	: Cortex_CMP\Debug\GLCD.c
*********************************************************************/
