/*********************************************************************
	Rhapsody in C	: 8.2.1 
	Login		: LocalAdministrator
	Component	: Cortex_CMP 
	Configuration 	: Debug
	Model Element	: GLCD
//!	Generated Date	: Sat, 19, Aug 2017  
	File Path	: Cortex_CMP\Debug\GLCD.h
*********************************************************************/

#ifndef GLCD_H
#define GLCD_H

/*## auto_generated */
#include "WST.h"
/*## auto_generated */
#include <stdint.h>
/*## auto_generated */
#include <stdbool.h>
/*## auto_generated */
#include "b_GraphicLibPkg.h"
/*## dependency lpc17xx */
#include <lpc17xx.h>
/*## dependency SPI */
#include "SPI.h"
/*## operation Init(orientation_t,position_t) */
#include "TypesPkg.h"
/*## package b_GraphicLibPkg */

/*## class GLCD */

/*#[ ignore */

/* Beginning start section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_START_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_START_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending start section to allocate CODE and DATA into Memory Sections */


/*#]*/


typedef struct GLCD GLCD;
struct GLCD
{
    uint16_t bgndColor;		/*## attribute bgndColor */
    int32_t bpp;		/*## attribute bpp */
    int32_t bypp;		/*## attribute bypp */
    int32_t height;		/*## attribute height */
    orientation_t orientation;		/*## attribute orientation */
    position_t position;		/*## attribute position */
    uint16_t textColor;		/*## attribute textColor */
    int32_t width;		/*## attribute width */
};

/***    User implicit entries    ***/


/* Constructors and destructors:*/

/* Initialize the Graphic LCD controller */
/*   Parameter: */
/*                    -          nothing */
/*  */
/*   Return: */
/*                    -          nothing */
/*## operation Init(orientation_t,position_t) */
void GLCD_Init(GLCD* const me, const orientation_t aLandscape, const position_t aPosition);

/* Display character on given line */
/*   Parameter:      */
/*                    ln:        line number */
/*                    col:      column number */
/*                    fi:         font index (0 = 6x8, 1 = 16x24) */
/*                    c:        ascii character */
/*    Return: */
/*                    -          nothing */
/*  */
/*## operation DisplayChar(uint16_t,uint16_t,uint8_t,int8_t) */
void GLCD_DisplayChar(GLCD* const me, const uint16_t aLine, const uint16_t aCol, const uint8_t aFont, const int8_t aChar);

/* Display string on given line */
/*   Parameter:      */
/*                   ln:       line number */
/*                   col:      column number */
/*                   fi:       font index (0 = 6x8, 1 = 16x24) */
/*                   s:        pointer to string  */
/*   Return:               */
/*                    -          nothing */
/*  */
/*  */
/*## operation DisplayString(uint16_t,uint16_t,uint8_t,int8_t) */
void GLCD_DisplayString(GLCD* const me, const uint16_t aLine, uint16_t aCol, const uint8_t aFont, int8_t* aString);

/* Draw character on given position */
/*   Parameter:       */
/*                   x:        horizontal position */
/*                   y:        vertical position      */
/*                   cw:       character width in pixel     */
/*                   ch:       character height in pixels     */
/*                   c:        pointer to character bitmap  */
/*   Return:                                       */
/*                    -          nothing */
/*  */
/*## operation DrawChar(uint16_t,uint16_t,uint16_t,uint16_t,int8_t) */
void GLCD_DrawChar(GLCD* const me, const uint16_t aX, const uint16_t aY, const uint16_t aCW, const uint16_t aCH, int8_t* aChar);

/* Clear display */
/*   Parameter:      */
/*               color:    display clearing color */
/*   Return: */
/*                    -          nothing */
/*  */
/*## operation Clear() */
void GLCD_Clear(GLCD* const me);

/* Clear display */
/*   Parameter:      */
/*               color:    display clearing color */
/*   Return: */
/*                    -          nothing */
/*  */
/*## operation ClearColor(uint16_t) */
void GLCD_ClearColor(GLCD* const me, const uint16_t aColor);

/* Clear given line */
/*   Parameter:      */
/*                  ln:       line number */
/*                   fi:       font index (0 = 6x8, 1 = 16x24) */
/*## operation ClearLn(uint16_t,uint8_t) */
void GLCD_ClearLn(GLCD* const me, const uint16_t ln, const uint8_t fi);

/* Draw bargraph */
/*    Parameter:      */
/*                    x:        horizontal position */
/*                    y:        vertical position */
/*                    w:        maximum width of bargraph (in pixels) */
/*                    h:        bargraph height */
/*                    val:      value of active bargraph (in 1/1024) */
/*    Return: */
/*                    -          nothing */
/*## operation BarGraph(uint16_t,uint16_t,uint16_t,uint16_t,uint16_t) */
void GLCD_BarGraph(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t w, const uint16_t h, const uint16_t val);

/* Display graphical bitmap image at position x horizontally and y vertically   */
/* (This function is optimized for 16 bits per pixel format, it has to be        */
/*  adapted for any other bits per pixel format)                                 */
/*   Parameter:       */
/*                   x:        horizontal position                               */
/*                   y:        vertical position                                 */
/*                   w:        width of bitmap                                 */
/*                   h:        height of bitmap                                */
/*                   bitmap:   address at which the bitmap data resides      */
/*   Return:                                */
/*## operation Bitmap(uint16_t,uint16_t,uint16_t,uint16_t,uint8_t) */
void GLCD_Bitmap(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t w, const uint16_t h, uint8_t* bitmap);

/*  Set draw window region to whole screen */
/*    Parameter: */
/*                    -          nothing */
/*  */
/*    Return: */
/*                    -          nothing */
/*  */
/*## operation WindowMax() */
void GLCD_WindowMax(GLCD* const me);

/* Draw a pixel in foreground color */
/*   Parameter:      */
/*                   x:        horizontal position */
/*                   y:        vertical position */
/*   Return: */
/*                    -          nothing */
/*  */
/*## operation PutPixel(uint16_t,uint16_t) */
void GLCD_PutPixel(GLCD* const me, const uint16_t x, const uint16_t y);

/* Set draw window region */
/*    Parameter:       */
/*                    x:        horizontal position */
/*                    y:        vertical position */
/*                    w:        window width in pixel */
/*                    h:        window height in pixels */
/*      Return: */
/*                    -          nothing */
/*  */
/*## operation SetWindow(uint16_t,uint16_t,uint16_t,uint16_t) */
void GLCD_SetWindow(GLCD* const me, const uint16_t aX, const uint16_t aY, const uint16_t aW, const uint16_t aH);

/* Scrolls content of the whole display for dy pixels vertically */
/*   Parameter: */
/*                dy:       number of pixels for vertical scroll */
/*   Return: */
/*                   -          nothing */
/*## operation ScrollVertical(uint16_t) */
void GLCD_ScrollVertical(GLCD* const me, const uint16_t dy);

/* Draw a pixel in foreground color */
/*   Parameter:      */
/*                   x:        horizontal position */
/*                   y:        vertical position */
/*   Return: */
/*                    -          nothing */
/*  */
/*## operation PutPixelColor(uint16_t,uint16_t,uint16_t) */
void GLCD_PutPixelColor(GLCD* const me, const uint16_t x, const uint16_t y, const uint16_t color);

/*## operation setBgndColor(uint16_t) */
void GLCD_setBgndColor(GLCD* const me, const uint16_t aVal);

/*## operation setTextColor(uint16_t) */
void GLCD_setTextColor(GLCD* const me, const uint16_t aVal);

/*                    -          nothing */
/*  */
/*                           */
/*## operation Cleanup() */
void GLCD_Cleanup(GLCD* const me);

/***    User explicit entries    ***/


/* Operations */

/*## auto_generated */
GLCD * GLCD_Create(const orientation_t aLandscape, const position_t aPosition);

/*## auto_generated */
void GLCD_Destroy(GLCD* const me);


/*#[ ignore */

/* Beginning stop section to allocate CODE and DATA into Memory Sections */

#define WST_APPL_RUNNING_STOP_SEC_DATA_NOINIT_UNSPECIFIED_FAST
#include "WSTMemoryTypes.h"

#define WST_APPL_RUNNING_STOP_SEC_CODE_FAST
#include "WSTMemoryTypes.h"

/* Ending stop section to allocate CODE and DATA into Memory Sections */


/*#]*/

#endif
/*********************************************************************
	File Path	: Cortex_CMP\Debug\GLCD.h
*********************************************************************/
